#ifndef TRACKNODE_HPP__
#define TRACKNODE_HPP__

#include "nodes/base/base.hpp"
#include <opencv2/opencv.hpp>
#include "common/meta.hpp"
#include "common/data.hpp"
#include "BYTETracker.h"
#include "infer/infer.hpp"

namespace GNode
{

class TrackNode : public BaseNode
{
public:
    TrackNode() = delete;
    TrackNode(const std::string& name, const std::string& track_label, int frame_rate=30, int track_buffer=30) : BaseNode(name, NODE_TYPE::MID_NODE) 
    {
        track_label_ = track_label;
        frame_rate_ = frame_rate;
        track_buffer_ = track_buffer;
        // tracker_ = std::make_shared<BYTETracker>(frame_rate, track_buffer);
    }
    virtual ~TrackNode()  { stop(); };
    void work() override;

private:
    // std::shared_ptr<BYTETracker> tracker_;
    std::unordered_map<std::string, std::shared_ptr<BYTETracker>> track_map_;
    std::string track_label_;

    int frame_rate_;
    int track_buffer_;

};

}

#endif  // TRACKNODE_HPP__